
#ifndef _1wire_H
#define _1wire_H

/** I N C L U D E S **********************************************************/
#include <pic18f87k22.h>

//ONE WIRE PORT PIN DEFINITION
///****************************************************
// This Configuration is required to make any PIC MicroController
// I/O pin as Open drain to drive 1-wire.
///****************************************************
#define OW_PIN_DIRECTION 	LATFbits.LATF2
#define OW_WRITE_PIN  		TRISFbits.TRISF2
#define OW_READ_PIN			PORTFbits.RF2

 
/** P R O T O T Y P E S ******************************************************/
void drive_one_wire_low (void);
void drive_one_wire_high (void);
unsigned char read__one_wire (void);
void OW_write_bit (unsigned char write_data);
unsigned char OW_read_bit (void);
unsigned char OW_reset_pulse(void);
void OW_write_byte (unsigned char write_data);
unsigned char OW_read_byte (void);

#endif