/*
 * File:   velwind.c
 * Author: Alberto Gmez Blzquez
 */


#include <xc.h>
#include <pic18f87k22.h>
#include <stdio.h>
#include "Windspeed.h"

//Variables para el calculo de la velocidad del viento

extern char TxdataAnemometro[16];
extern unsigned int Pulsos;
extern unsigned char Time_out;
extern unsigned int NumPulsos; 

void Read_SpeedWind_Int(void) {

    setup_timer_0(); //Timer0 como base de 2.4 segundos
    // Habilito interrupcin en RB2 
    INTEDG2 = 1; // INT2 edge selection: '0' --> on falling edge (interrupt after clicking the pushbutton)
    INT2IE = 1; // Enable interrupts from the INT2 pin
    NumPulsos = 0; //Reseteo contador
    TMR0ON = 1; // Start Timer0
    
    while (Time_out); //Espero a que acabe el periodo de 2,4 segundos
    
    INT2IE = 0; // Disable interrupts from the INT2 pin
    TMR0ON = 0; // Stop Timer0
    
    sprintf(TxdataAnemometro, "<Vel>: %d Km/h;", Pulsos);
    
    Pulsos = 0; //Reseteo contador pulsos
    Time_out = 1; //Reseteo flag tiempo 2.4 segundos
}
